import * as plugins from './sdk.plugins';
import { AuthInfo } from './sdk.classes.authinfo';

export interface IRequirementResult {
  allOk: boolean;
  reason: string;
}

export abstract class AAgHandler<TClaim> {
  /**
   * a slug that separates the handler from other handlers
   */
  public abstract slug: string;
  public abstract typedrouter: plugins.typedrequest.TypedRouter; 
  public abstract checkRequirements(): Promise<IRequirementResult>;

  /**
   * start the ag-handler
   */
  public abstract start(): Promise<any>;
  public abstract stop(): Promise<any>;
}
